<?php
namespace Controller;

use Service\DeleteCascadeService;
use Service\StyleService;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Util\Utilities;
use Service\Traits\TResponse;

class Style extends Crud {

    use TResponse;

	protected $dataSourceName = 'style';

	/** @var StyleService */
    protected $styleService;

	public function __construct(Manager $mongoManager, DeleteCascadeService $deleteCascadeService, $styleService) {
		parent::__construct($mongoManager, $deleteCascadeService);
        $this->styleService = $styleService;
        $this->mongoManager->createDatabase(\Util\Utilities::getOrganizationIdForMongo());
        $this->orderFields = [];
	}

    public function findNext(DTO\Request $request, DTO\Response $response) {
        try{
            $params = $request->getParameters();
            $style = $this->styleService->getStyleGeneral($params);
            $style = Utilities::parseDataSourceZeedhiNext($style);
            $this->sendResponse(Utilities::paginationAndOrderINPhpNext($style, $params), 200);
        } catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
