<?php
namespace Controller;

use Service\DeleteCascadeService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Util\Utilities;

class ZmartLog extends Crud
{
    protected $dataSourceName = 'zmartLog';

    /** @var \Service\Manager\Mongo\Manager */
    protected $organizationMongoManager;

    public function __construct(Manager $organizationMongoManager, DeleteCascadeService $deleteCascadeService)
    {
        $this->organizationMongoManager = $organizationMongoManager;
        parent::__construct($organizationMongoManager, $deleteCascadeService);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        $sort = $this->mongoManager->processSort($filterData);
        if(empty($sort)){
            $sort = array("DATA_UPDATE" =>-1 );
        }
        $dataSet = $this->mongoManager->findByPagination($filterData,$sort);
        $response->addDataSet($dataSet);
        $dataSet = $response->getDataSets()[0];
        Utilities::datasetMongoToZeedhi($response, $dataSet,$this->dataSourceName);

    }




}
